# OpenStack Rancher

## Installation

1. Clone this repository to your local computer.

1. Copy the example .tfvars file.

    ```sh
    cp terraform.tfvars.example terraform.tfvars
    ```

1. Your OpenStack credentials can be fetched from the OpenStack web UI:

    ![OpenStack account dropdown](assets/openstack-account-dropdown.png)

    Download the 'OpenStack RC File v3' file and copy the values to your `terraform.tfvars` file.

1. Initialize Terraform.

    ```sh
    terraform init
    ```

1. Create the bastion cluster.

    ```sh
    terraform apply
    ```

1. Verify Rancher pods are running

    ```sh
    export KUBECONFIG=$PWD/kubeconfig.yaml
    kubectl get pod
    ```

1. Login to the console (you can ignore the self-signed certificate and continue)

    Follow instructions on the login page:

    ```sh
    open $(terraform output -json | jq -r '.rancher_url.value')
    ```

1. Create Rancher configuration so Rancher can access OpenStack

    Replace your OpenStack and Terraform output below and apply it to the bastion cluster:

    ```yaml
    apiVersion: rke-machine-config.cattle.io/v1
    kind: OpenstackConfig
    metadata:
      name: mycluster
      namespace: fleet-default
      annotations:
        ownerBindingsCreated: "true"
    activeTimeout: "200"
    applicationCredentialId: null
    applicationCredentialName: null
    applicationCredentialSecret: null
    authUrl: https://identity.openstack.cloudvps.com/v3
    availabilityZone: null
    bootFromVolume: false
    cacert: null
    configDrive: false
    domainId: <OS_PROJECT_DOMAIN_ID>
    domainName: null
    endpointType: null
    flavorName: Standard 4GB
    floatingipPool: null
    imageName: Ubuntu 22.04 (LTS)
    insecure: false
    ipVersion: "4"
    keypairName: <your ssh-key file name reference in OpenStack, run `terraform output -json | jq -r '.ssh_key_pair_name.value'`>
    netId: null
    netName: net-public
    novaNetwork: false
    password: <OS_PASSWORD>
    privateKeyFile: |
      <your ssh private key generated by Terraform, run `terraform output -json | jq -r '.ssh_private_key_contents.value'`>
    region: AMS
    secGroups: null
    sshPort: "22"
    sshUser: ubuntu
    tenantDomainId: null
    tenantDomainName: null
    tenantId: <OS_PROJECT_ID>
    tenantName: <OS_PROJECT_NAME>
    userDataFile: null
    userDomainId: null
    userId: null
    username: <OS_USERNAME>
    volumeDevicePath: null
    volumeId: null
    volumeName: null
    volumeSize: "0"
    volumeType: null
    ```

1. Now create a 3 node cluster resource:

    ```yaml
    apiVersion: provisioning.cattle.io/v1
    kind: Cluster
    metadata:
      name: mycluster
      namespace: fleet-default
    spec:
      cloudCredentialSecretName: cattle-global-data:openstack-node-config
      kubernetesVersion: v1.26.8+rke2r1
      rkeConfig:
        chartValues:
          rke2-calico: {}
        etcd:
          disableSnapshots: false
          snapshotRetention: 5
          snapshotScheduleCron: 0 */5 * * *
        machineGlobalConfig:
          cni: calico
          disable-kube-proxy: false
          etcd-expose-metrics: false
          profile: null
        machinePools:
        - name: pool1
          etcdRole: true
          controlPlaneRole: true
          workerRole: true
          hostnamePrefix: ''
          quantity: 3
          unhealthyNodeTimeout: 0m
          machineConfigRef:
            kind: OpenstackConfig
            name: mycluster
    ```

    A 3 node cluster should appear in the Rancher web UI.

## Destroy the environment

1. Destroy all Rancher clusters:

    ```sh
    kubectl delete cluster.provisioning.cattle.io --all -n fleet-default
    ```

1. Destroy the bastion cluster:

  ```sh
  terraform state rm kubernetes_namespace_v1.cattle_system
  terraform state rm kubernetes_namespace_v1.flux_system
  terraform state rm flux_bootstrap_git.this
  terraform destroy
  ```
